defmodule Amethyst.API.Game do
  @moduledoc """
  This module includes the interface for defining and registering
  a game with Amethyst.
  """
  @callback instantiate() :: {:ok, new_state :: term} | {:error, reason :: term}

  defmacro __using__(opts) do
    meta = Keyword.get(opts, :meta, [])
    quote do
      @behaviour Amethyst.API.Game
        def child_spec(state) do
          %{
            id: __MODULE__,
            start: {__MODULE__, :start_link, []}
          }
        end
        def start_link() do
          register_self()
          _loop()
        end
        defp _loop() do
          _loop()
        end
        def register_self() do
          Amethyst.GameRegistry.register(__MODULE__, unquote(meta))
        end
    end
  end
end
